﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace JedenHrac
{
    class Program
    {
        static WebClient wc = new WebClient();

        static int gameNumber = -1;
        static int remainingMoves = 0;
        static Player player;
        static List<Treasure> treasures = new List<Treasure>();
        static List<Point> queue = new List<Point>();

        static List<Treasure> stolen = new List<Treasure>();

        static List<Treasure> bestStolen;
        static int bestValue = 0;
        static int bestMoves = 0;


        static byte[,] field = new byte[10, 10];
        static bool[,] flooded = new bool[10, 10];

        static void Main(string[] args)
        {
            Console.WriteLine("Zadejte adresu serveru (ponechat prázdné pro localhost:8000):");
            string server = Console.ReadLine();
            if(server == "") server = "localhost:8000";
            Parse(wc.DownloadString(String.Format(@"http://{0}/start", server)));

            queue.Add(new Point(player.R, player.S, 0, ""));
            
                while (queue.Count > 0)
                {
                    Point pt = queue[0];
                    Flood(pt.x, pt.y, pt.dist, pt.path);
                    queue.Remove(pt);
                    queue.Sort();
                }
            

            for (int i = 0; i < treasures.Count; i++)
            {
                Steal(treasures[i], treasures[i].Distance, treasures[i].Value);
            }

            string response = "";

            foreach (Treasure treasure in bestStolen)
            {
                for (int i = 0; i < treasure.Path.Length; i++)
                {
                    response = wc.DownloadString("http://" + server + string.Format("/tah?id={0}&pohyb={1}", gameNumber, treasure.Path[i]));
                }
                for (int i = treasure.Path.Length - 1; i >= 0; i--)
                {
                    response = wc.DownloadString("http://" + server + string.Format("/tah?id={0}&pohyb={1}", gameNumber, invert(treasure.Path[i])));
                }
            }
            while(!response.Contains("Konec") && !response.Contains("Chyba"))
            {
                response = wc.DownloadString("http://" + server + string.Format("/tah?id={0}&pohyb={1}", gameNumber, 'N'));
            }

            Console.WriteLine(response);
        }

        static char invert(char c)
        {
            switch (c)
            {
                case 'N':
                    return 'D';
                case 'D':
                    return 'N';
                case 'L':
                    return 'P';
                case 'P':
                    return 'L';
                default:
                    return 'Ž';
            }

        }

        static string invertstring(string str)
        {
            StringBuilder sb = new StringBuilder();
            for(int i = 0;i<str.Length;i++)
            {
                sb.Append(invert(str[i]));
            }
            return sb.ToString();
        }

        static void Steal(Treasure treasure, int sum, int value)
        {
            if (sum > remainingMoves)
            {
                return;
            }

            treasures.Remove(treasure);
            stolen.Add(treasure);
            if (value > bestValue)
            {
                bestStolen = new List<Treasure>(stolen);
                bestValue = value;
                bestMoves = sum;
            }



            for (int i = 0; i < treasures.Count; i++)
            {
                Steal(treasures[i], sum + treasures[i].Distance, value + treasures[i].Value);
            }

            treasures.Add(treasure);
            stolen.Remove(treasure);
        }

        static void Flood(int x, int y, int dist, string path)
        {
            
            if (x < 0 || y < 0 || x > 9 || y > 9) return;
            if (flooded[x, y]) return;
            flooded[x, y] = true;

            if (field[x, y] > 252) return;

            if (field[x, y] < 200)
            {
                treasures.Add(new Treasure(dist * 2, field[x, y], path));
                dist += dist;
            }

            queue.Add(new Point(x + 1, y, dist + 1, path + "D"));
            queue.Add(new Point(x - 1, y, dist + 1, path + "N"));
            queue.Add(new Point(x, y + 1, dist + 1, path + "P"));
            queue.Add(new Point(x, y - 1, dist + 1, path + "L"));
        }

        static void Parse(string Response)
        {
            if (Response.Split('\n').Length < 13)
            {
                Console.WriteLine(Response);
            }
            else
            {
                string[] lines = Response.Split('\n');

                gameNumber = int.Parse(lines[0].Trim());
                remainingMoves = int.Parse(lines[1].Trim());
                for (int i = 0; i < 10; i++)
                {
                    for (int j = 0; j < 10; j++)
                    {
                        char ch = lines[i + 2][j * 2];
                        if (ch == '.') field[i, j] = 201;
                        else if (ch == 'X') field[i, j] = 255;
                        else if (ch == '+') field[i, j] = 252;
                        else if (ch == '-') field[i, j] = 254;
                        else field[i, j] = byte.Parse(lines[i + 2].Substring(j * 2, 2));
                    }
                }



                player = new Player(lines[12].Trim());
                field[player.R, player.S] = 251;
            }
        }


    }

    class Player
    {
        public int S;
        public int R;
        public int P;
        public int C;

        public Player(string PlayerInfo)
        {
            string[] Splitted = PlayerInfo.Split(' ');
            S = int.Parse(Splitted[0].Trim()) - 1;
            R = int.Parse(Splitted[1].Trim()) - 1;
            P = int.Parse(Splitted[2].Trim());
            C = int.Parse(Splitted[3].Trim());
        }
    }

    class Treasure
    {
        public int Distance;
        public int Value;
        public string Path;

        public Treasure(int Distance, int Value, string Path)
        {
            this.Distance = Distance;
            this.Value = Value;
            this.Path = Path;
        }
    }

    class Point : IComparable
    {
        public int x;
        public int y;
        public int dist;
        public string path;
        public Point(int x, int y, int dist, string path)
        {
            this.x = x;
            this.y = y;
            this.dist = dist;
            this.path = path;
        }

        public int CompareTo(object obj)
        {
            if (obj == null) return 1;

            Point otherPoint = obj as Point;
            if (otherPoint != null)
                return this.dist.CompareTo(otherPoint.dist);
            else
                throw new ArgumentException("Object is not a Point");
        }
    }
}
